// $Id: Joystick.hh,v 1.9 2002/05/27 19:31:57 m9710797 Exp $

#ifndef __JOYSTICK_HH__
#define __JOYSTICK_HH__

#include "JoystickDevice.hh"
#include "EventListener.hh"
#include "MSXException.hh"
#include <SDL/SDL.h>


class JoystickException : public MSXException {
	public:
		JoystickException(const std::string &desc) : MSXException(desc) {}
};

class Joystick : public JoystickDevice, EventListener
{
	public:
		Joystick(int joyNum);
		virtual ~Joystick();

		//Pluggable
		virtual const std::string &getName();
		
		//JoystickDevice
		virtual byte read(const EmuTime &time);
		virtual void write(byte value, const EmuTime &time);

		//EventListener
		virtual void signalEvent(SDL_Event &event);

	private:
		static const int THRESHOLD = 32768/10;

		std::string name;

		static bool SDLJoysticksInitialized;
		int joyNum;
		SDL_Joystick* joystick;
		byte status;
};
#endif
