// $Id: PrinterPortSimpl.cc,v 1.1 2002/05/27 19:31:57 m9710797 Exp $

#include <cassert>
#include "PrinterPortSimpl.hh"
#include "DACSound.hh"
#include "PluggingController.hh"
#include "sound/DACSound.hh"


PrinterPortSimpl::PrinterPortSimpl()
{
	PRT_DEBUG("Creating an PrinterPortSimpl");
	dac = NULL;
	PluggingController::instance()->registerPluggable(this);
}

PrinterPortSimpl::~PrinterPortSimpl()
{
	PluggingController::instance()->unregisterPluggable(this);
	delete dac;	// unplug();
}

bool PrinterPortSimpl::getStatus(const EmuTime &time)
{
	return true;	// TODO check
}

void PrinterPortSimpl::setStrobe(bool strobe, const EmuTime &time)
{
	// ignore strobe	TODO check
}

void PrinterPortSimpl::writeData(byte data, const EmuTime &time)
{
	dac->writeDAC(data,time);
}

void PrinterPortSimpl::plug(const EmuTime &time)
{
	short volume = 12000;	// TODO read from config 
	dac = new DACSound(volume, 16000, time);
}

void PrinterPortSimpl::unplug(const EmuTime &time)
{
	delete dac;
	dac = NULL;
}

const std::string &PrinterPortSimpl::getName()
{
	return name;
}
const std::string PrinterPortSimpl::name("simpl");
